#include "usart.h"


void usart_init()
{
    /* seteaza baud rate la 9600 */
    UBRR0H = 0;
    UBRR0L = 103;

    /* porneste transmitatorul */
    UCSR0B = (1<<TXEN0) | (1<<RXEN0) | (1<<RXCIE0);;

    /* seteaza formatul frame-ului: 8 biti de date, 1 bit de stop, fara paritate */
    UCSR0C = (3<<UCSZ00);
}


void usart_data_transmit(unsigned char data )
{
    while ( !( UCSR0A & (1<<UDRE0)) )
    ;
    UDR0 = data;
    _delay_ms(1);
}

unsigned char usart_data_receive( void )
{
    /* asteapta cat timp bufferul e gol */
    while(!(UCSR0A & (1<<RXC0)));

    /* returneaza datele din buffer */
    return UDR0;
}

void usart_string_transmit(char *string)
{
    while(*string)
    {
        usart_data_transmit(*string++);
    }
}

char *usart_string_receive(char *receive_string,unsigned char terminating_character)
{
    unsigned char temp=0x00;
    for(unsigned char i=0;;i++)
    {
        *(receive_string+i)=usart_data_receive();
        if(*(receive_string+i)==terminating_character)
            break;
        else
        temp++;
    }
    *(receive_string+temp)='\0';
    return receive_string;
}